@echo off

REM ------------------------------------------------------------------------------
REM	.NET Frameworko[Wopob`Et@Ci2012N1026Łj
REM
REM	Windows TIPSF .NET Framework̃o[WmF@
REM	http://www.atmarkit.co.jp/ait/articles/1210/26/news086.html
REM	Copyright (C) 2000-2012 Digital Advantage Corp.
REM ------------------------------------------------------------------------------

setlocal

REM ----- i[gERs[^j̊mF
if %1. == . (
	set RemoteName=
	echo ----- Local computeri%COMPUTERNAME%j -----
) else (
	set RemoteName=%1\
	echo ----- %1 -----
)

REM ----- WXgɎQƂł邩mF
reg query %RemoteName%HKLM\SOFTWARE\Microsoft 1>nul
if errorlevel 1 (
	echo %0F Registry can not be referenced. An error occurred.
	endlocal
	exit /b
)

REM ----- WXgEGg̎w
set RegKey11=%RemoteName%HKLM\SOFTWARE\Microsoft\NET Framework Setup\NDP

REM ----- eo[W̊mF
call :Detect10
call :Detect11_35 ".NET Framework 1.1" "%RegKey11%\v1.1.4322"
call :Detect11_35 ".NET Framework 2.0" "%RegKey11%\v2.0.50727"
call :Detect11_35 ".NET Framework 3.0" "%RegKey11%\v3.0"
call :Detect11_35 ".NET Framework 3.5" "%RegKey11%\v3.5"
call :Detect4     ".NET Framework 4"   "%RegKey11%\v4"

REM ----- I
endlocal
exit /b

REM --------------------------------------
REM ----- .NET Framework 1.0̌o
:Detect10
set RegKey10_Inst=%RemoteName%HKLM\SOFTWARE\Microsoft\NET Framework Setup\Full\v1.0.3705\1041\Microsoft .NET Framework Full v1.0.3705 (1041)
set RegKey10_SP=%RemoteName%HKLM\SOFTWARE\Microsoft\Active Setup\Installed Components
REM ----- CXg[̊mF
reg query "%RegKey10_Inst%" /v "Install" 2>nul | find /I "Install" 2>nul | find /I "0x1" 1>nul 2>nul
if errorlevel 1 goto NoExist10
REM ----- Service Packx̊mF
reg query "%RegKey10_SP%\{78705f0d-e8db-4b2d-8193-982bdda15ecd}" /v "Version" 2>nul | find /I "Version" 1>  temp-RegOut.log 2>nul
reg query "%RegKey10_SP%\{FDC11A6F-17D1-48f9-9EA3-9051954BAA24}" /v "Version" 2>nul | find /I "Version" 1>> temp-RegOut.log 2>nul
REM ----- ł̊mF
find /I "1,0,3705,0" temp-RegOut.log 1>nul 2>nul && echo .NET Framework 1.0 Initial version installed
REM ----- SP1^SP2^SP3̊mF
for %%i in (1 2 3) do (find /I "1,0,3705,%%i" temp-RegOut.log 1>nul 2>nul && echo .NET Framework 1.0 Service Pack %%i installed.)
:NoExist10
if exist temp-RegOut.log del temp-RegOut.log
exit /b
REM -----

REM --------------------------------------
REM ----- .NET Framework 1.1^2.0^3.0^3.5 ̌o 
:Detect11_35
REM ----- CXg[̊mF
reg query "%~2" /v "Install" 2>nul | find /I "Install" 2>nul | find /I "0x1" 1>nul 2>nul
if errorlevel 1 goto NoExist11
reg query "%~2" /v "SP" 2>nul | find /I "SP" 1> temp-RegOut.log 2>nul
if errorlevel 1 goto NoExist11
REM ----- ł̊mF
find /I "0x0" temp-RegOut.log 1>nul 2>nul && echo %~1 Initial version installed
REM ----- SP1^SP2^SP3̊mF
for %%i in (1 2 3) do (find /I "0x%%i" temp-RegOut.log 1>nul 2>nul && echo %~1 Service Pack %%i installed.)
REM ----- { Language Pack̊mF
REM set LangPath=
REM reg query "%~2\Setup\1041" /v "Install" 2>nul | find /I "Install" 2>nul | find /I "0x1" 1>nul 2>nul && set LangPath=%~2\Setup\1041
REM reg query "%~2\1041"       /v "Install" 2>nul | find /I "Install" 2>nul | find /I "0x1" 1>nul 2>nul && set LangPath=%~2\1041
REM if "%LangPath%" == "" (
REM 	echo @{Language Pack̓CXg[Ă܂
REM ) else (
REM 	reg query "%LangPath%" /v "SP" 2>nul | find /I "SP" 1> temp-RegOut.log 2>nul
REM 	find /I "0x0" temp-RegOut.log 1>nul 2>nul && echo @{Language PackiŁjCXg[ς݂ł
REM 	for %%i in (1 2 3) do (find /I "0x%%i" temp-RegOut.log 1>nul 2>nul && echo @{Language PackiService Pack %%ijCXg[ς݂ł)
REM )
:NoExist11
if exist temp-RegOut.log del temp-RegOut.log
exit /b
REM -----

REM --------------------------------------
REM ----- .NET Framework 4^4.5 ̌o 
:Detect4
REM ----- ^C̃CXg[̊mF
reg query "%~2\Full" /v "Install" 2>nul | find /I "Install" 2>nul | find /I "0x1" 1>nul 2>nul
if not errorlevel 1 (
REM ----- ^C̃o[W̊mFi4.5j
	reg query "%~2\Full" /v "Version" 2>nul | find /I "Version" 2>nul | find /I "4.5." 1>nul 2>nul
	if not errorlevel 1 (
		echo .NET Framework 4.5 installed
REM ----- { Language Pack̃CXg[̊mFi4.5j
REM		reg query "%~2\Full\1041" /v "Install" 2>nul | find /I "Install" 2>nul | find /I "0x1" 1>nul 2>nul
REM		if not errorlevel 1 (
REM ----- { Language Pack̃o[W̊mFi4.5j
REM			reg query "%~2\Full\1041" /v "Version" 2>nul | find /I "Version" 2>nul | find /I "4.5." 1>nul 2>nul
REM			if not errorlevel 1 (
REM				echo @{Language PackCXg[ς݂ł
REM			) else (
REM				reg query "%~2\Full\1041" /v "Version" 2>nul | find /I "Version" 2>nul | find /I "4.0." 1>nul 2>nul
REM				if not errorlevel 1 (
REM					echo @.NET Framework 4p̓{Language PackCXg[Ă܂
REM				) else (
REM					echo @o[Ws̓{Language PackCXg[Ă܂
REM				)
REM			)
REM		) else (
REM			echo @{Language Pack̓CXg[Ă܂
REM		)
	) else (
REM ----- ^C̃o[W̊mFi4 tj
		reg query "%~2\Full" /v "Version" 2>nul | find /I "Version" 2>nul | find /I "4.0." 1>nul 2>nul
		if not errorlevel 1 (
			echo .NET Framework 4iFullj installed
REM ----- { Language Pack̃CXg[̊mFi4 tj
REM			reg query "%~2\Full\1041" /v "Install" 2>nul | find /I "Install" 2>nul | find /I "0x1" 1>nul 2>nul
REM			if not errorlevel 1 (
REM ----- { Language Pack̃o[W̊mFi4 tj
REM				reg query "%~2\Full\1041" /v "Version" 2>nul | find /I "Version" 2>nul | find /I "4.0." 1>nul 2>nul
REM				if not errorlevel 1 (
REM					echo @{Language PackitŁj CXg[ς݂ł
REM				) else (
REM					echo @o[Ws̓{Language PackCXg[Ă܂
REM				)
REM			) else (
REM				echo @{Language Pack̓CXg[Ă܂
REM			)
		) else (
			echo Some version of.NET Framework 4.xiFulljinstalled
		)
	)
) else (
REM ----- ^C̃CXg[̊mFi4 NCAgEvt@Cj
	reg query "%~2\Client" /v "Install" 2>nul | find /I "Install" 2>nul | find /I "0x1" 1>nul 2>nul
	if not errorlevel 1 (
REM ----- ^C̃o[W̊mFi4 NCAgEvt@Cj
		reg query "%~2\Client" /v "Version" 2>nul | find /I "Version" 2>nul | find /I "4.0." 1>nul 2>nul
		if not errorlevel 1 (
			echo .NET Framework 4iClient profile versionj installed
REM ----- { Language Pack̃CXg[̊mFi4 NCAgEvt@Cj
REM			reg query "%~2\Client\1041" /v "Install" 2>nul | find /I "Install" 2>nul | find /I "0x1" 1>nul 2>nul
REM			if not errorlevel 1 (
REM ----- { Language Pack̃o[W̊mFi4 NCAgEvt@Cj
REM				reg query "%~2\Client\1041" /v "Version" 2>nul | find /I "Version" 2>nul | find /I "4.0." 1>nul 2>nul
REM				if not errorlevel 1 (
REM					echo @{Language PackiNCAgEvt@CŁj CXg[ς݂ł
REM				) else (
REM					echo @o[Ws̓{Language PackCXg[Ă܂
REM				)
REM			) else (
REM				echo @{Language Pack̓CXg[Ă܂
REM			)
		) else (
			echo Some version of .NET Framework 4.xiClient profile versionj installed
		)
	)
)
exit /b
REM -----